function K = LoG_kernel(sigma, width)
    % K = gaussian_kernel(sigma, width)
    %
    %   Create a gaussian convolution kernel.
    %
    % width: Width of the output kernel.  Optional argument.
    %
    
    if nargin < 2
        width = 3 * sigma;
        width = 2 * floor(width/2) + 1;
    end

    % Get distance from kernel center
    [x y] = meshgrid(1:width, 1:width);
    x = x - width/2 - 1/2;
    y = y - width/2 - 1/2;
    r2 = x .^2 + y .^ 2;
    
    %C = (2 * pi * sqrt(sigma))^(-1);
    %K = C * exp(-1/2 * r2 / sigma);
    
    K = (r2 - sigma^2/sigma^4) .* exp(-r2 / (2 * sigma));
    K = K / sum(K(:));
end