#ifndef __CLUSTER_GONZALEZ85_H__
#define __CLUSTER_GONZALEZ85_H__

#include <stdlib.h>

/**
 * 2-approximate min-max clustering by algorithm in Gonzalez 1985.
 *
 * @arg @c k Maximum number of clusters.
 * @arg @c mindist Distance at which we stop generating new clusters.
 *
 * @return Number of clusters created.
 */
size_t gonzalez85(size_t n, size_t ndims, const double *p,
                  size_t k, double mindist,
                  double *C, int *part);

#endif /* #ifndef __CLUSTER_GONZALEZ85_H__ */
