function mask = conv2_valid(I, K)
    Ih = size(I, 1);
    Iw = size(I, 2);

    % TODO: handling of even-size K
    Ksize = size(K);
    Ksize(mod(Ksize, 2) == 0) = Ksize(mod(Ksize, 2) == 0) + 1;

    % Find size of padding pixels on each size
    pad = floor(Ksize/2);
    pady = pad(1);
    padx = pad(2);
    
    % Construct mask
    [x y] = meshgrid(1:Iw, 1:Ih);
    
    mask = ones(Ih, Iw);
    mask(x <= padx | y <= pady | x > Iw - padx | y > Ih - pady) = 0;
end