function K = gaussian_derivative_kernel(sigma, dir, size)
    
    if nargin < 3
        size = 5 * sigma;
        size = 2 * floor(size/2) + 1;
    end

    if numel(size) == 1
        size = [size size];
    end

    % Get distance from kernel center
    [x y] = meshgrid(1:size(1), 1:size(2));
    x = x - size(1)/2 - 1/2;
    y = y - size(2)/2 - 1/2;
    r2 = x .^2 + y .^ 2;
    
    C = (2 * pi * sqrt(sigma))^(-1);
    %K = C * exp(-1/2 * r2 / sigma^2);
    
    K = C * exp(-r2 / (2 * sigma^2));
    K = (dir(1) * x/sigma^2 + dir(2) * y/sigma^2) .* K;
    %K = K / sum(K(:));
end