% Load input
I = cell(5,1);
seeds = cell(5,1);
for i=1:5
    I{i} = imread(sprintf('images/kendo-small%d.png', i));
    seeds{i} = seed_file(sprintf('images/kendo-small-seeds%d.png', i));
end

% Generate texture histogram
[textonr, textonmask] = winn_filters(I);
H = cluster_hist(textonr, textonmask, -1);

% Perform segmentation
params.lambda = 1e-7;
[seg status] = random_walker_cosegmentation(I, H, seeds, params);

% Display segmentation
figure('Position', [100 100 1000 300])
for i=1:5
    subplot(1, 5, i);
    boundary_plot(I{i}, seg{i}, seeds{i});
    
    set(gca, 'Position', [(i-1)/5.1 + 0.01 0.025 0.18 0.95])
end
